<a id="types-aiobotocore-athena"></a>

# types-aiobotocore-athena

[![PyPI - types-aiobotocore-athena](https://img.shields.io/pypi/v/types-aiobotocore-athena.svg?color=blue)](https://pypi.org/project/types-aiobotocore-athena)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-athena.svg?color=blue)](https://pypi.org/project/types-aiobotocore-athena)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-athena?color=blue)](https://pypistats.org/packages/types-aiobotocore-athena)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.Athena 2.5.0](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/athena.html#Athena)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.13.0](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-athena docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_athena/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-athena](#types-aiobotocore-athena)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Athena` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[athena]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[athena]'


# standalone installation
python -m pip install types-aiobotocore-athena
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-athena
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[athena]` in your environment:

```bash
python -m pip install 'types-aiobotocore[athena]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[athena]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[athena]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[athena]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[athena]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[athena]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[athena]` in your environment:

```bash
python -m pip install 'types-aiobotocore[athena]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[athena]` in your environment:

```bash
python -m pip install 'types-aiobotocore[athena]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`AthenaClient` provides annotations for `session.create_client("athena")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_athena import AthenaClient

session = get_session()
async with session.create_client("athena") as client:
    client: AthenaClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_athena.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_athena import AthenaClient
from types_aiobotocore_athena.paginator import (
    GetQueryResultsPaginator,
    ListDataCatalogsPaginator,
    ListDatabasesPaginator,
    ListNamedQueriesPaginator,
    ListQueryExecutionsPaginator,
    ListTableMetadataPaginator,
    ListTagsForResourcePaginator,
)

session = get_session()
async with session.create_client("athena") as client:
    client: AthenaClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    get_query_results_paginator: GetQueryResultsPaginator = client.get_paginator(
        "get_query_results"
    )
    list_data_catalogs_paginator: ListDataCatalogsPaginator = client.get_paginator(
        "list_data_catalogs"
    )
    list_databases_paginator: ListDatabasesPaginator = client.get_paginator("list_databases")
    list_named_queries_paginator: ListNamedQueriesPaginator = client.get_paginator(
        "list_named_queries"
    )
    list_query_executions_paginator: ListQueryExecutionsPaginator = client.get_paginator(
        "list_query_executions"
    )
    list_table_metadata_paginator: ListTableMetadataPaginator = client.get_paginator(
        "list_table_metadata"
    )
    list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator(
        "list_tags_for_resource"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_athena.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_athena.literals import (
    CalculationExecutionStateType,
    ColumnNullableType,
    DataCatalogTypeType,
    EncryptionOptionType,
    ExecutorStateType,
    ExecutorTypeType,
    GetQueryResultsPaginatorName,
    ListDataCatalogsPaginatorName,
    ListDatabasesPaginatorName,
    ListNamedQueriesPaginatorName,
    ListQueryExecutionsPaginatorName,
    ListTableMetadataPaginatorName,
    ListTagsForResourcePaginatorName,
    NotebookTypeType,
    QueryExecutionStateType,
    S3AclOptionType,
    SessionStateType,
    StatementTypeType,
    WorkGroupStateType,
    AthenaServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: CalculationExecutionStateType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_athena.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_athena.type_defs import (
    AclConfigurationTypeDef,
    ApplicationDPUSizesTypeDef,
    AthenaErrorTypeDef,
    BatchGetNamedQueryInputRequestTypeDef,
    NamedQueryTypeDef,
    ResponseMetadataTypeDef,
    UnprocessedNamedQueryIdTypeDef,
    BatchGetPreparedStatementInputRequestTypeDef,
    PreparedStatementTypeDef,
    UnprocessedPreparedStatementNameTypeDef,
    BatchGetQueryExecutionInputRequestTypeDef,
    UnprocessedQueryExecutionIdTypeDef,
    CalculationConfigurationTypeDef,
    CalculationResultTypeDef,
    CalculationStatisticsTypeDef,
    CalculationStatusTypeDef,
    ColumnInfoTypeDef,
    ColumnTypeDef,
    TagTypeDef,
    CreateNamedQueryInputRequestTypeDef,
    CreateNotebookInputRequestTypeDef,
    CreatePreparedStatementInputRequestTypeDef,
    CreatePresignedNotebookUrlRequestRequestTypeDef,
    CustomerContentEncryptionConfigurationTypeDef,
    DataCatalogSummaryTypeDef,
    DataCatalogTypeDef,
    DatabaseTypeDef,
    DatumTypeDef,
    DeleteDataCatalogInputRequestTypeDef,
    DeleteNamedQueryInputRequestTypeDef,
    DeleteNotebookInputRequestTypeDef,
    DeletePreparedStatementInputRequestTypeDef,
    DeleteWorkGroupInputRequestTypeDef,
    EncryptionConfigurationTypeDef,
    EngineConfigurationTypeDef,
    EngineVersionTypeDef,
    ExecutorsSummaryTypeDef,
    ExportNotebookInputRequestTypeDef,
    NotebookMetadataTypeDef,
    FilterDefinitionTypeDef,
    GetCalculationExecutionCodeRequestRequestTypeDef,
    GetCalculationExecutionRequestRequestTypeDef,
    GetCalculationExecutionStatusRequestRequestTypeDef,
    GetDataCatalogInputRequestTypeDef,
    GetDatabaseInputRequestTypeDef,
    GetNamedQueryInputRequestTypeDef,
    GetNotebookMetadataInputRequestTypeDef,
    GetPreparedStatementInputRequestTypeDef,
    GetQueryExecutionInputRequestTypeDef,
    PaginatorConfigTypeDef,
    GetQueryResultsInputRequestTypeDef,
    GetQueryRuntimeStatisticsInputRequestTypeDef,
    GetSessionRequestRequestTypeDef,
    SessionStatisticsTypeDef,
    SessionStatusTypeDef,
    GetSessionStatusRequestRequestTypeDef,
    GetTableMetadataInputRequestTypeDef,
    GetWorkGroupInputRequestTypeDef,
    ImportNotebookInputRequestTypeDef,
    ListApplicationDPUSizesInputRequestTypeDef,
    ListCalculationExecutionsRequestRequestTypeDef,
    ListDataCatalogsInputRequestTypeDef,
    ListDatabasesInputRequestTypeDef,
    ListEngineVersionsInputRequestTypeDef,
    ListExecutorsRequestRequestTypeDef,
    ListNamedQueriesInputRequestTypeDef,
    ListNotebookSessionsRequestRequestTypeDef,
    NotebookSessionSummaryTypeDef,
    ListPreparedStatementsInputRequestTypeDef,
    PreparedStatementSummaryTypeDef,
    ListQueryExecutionsInputRequestTypeDef,
    ListSessionsRequestRequestTypeDef,
    ListTableMetadataInputRequestTypeDef,
    ListTagsForResourceInputRequestTypeDef,
    ListWorkGroupsInputRequestTypeDef,
    QueryExecutionContextTypeDef,
    ResultReuseInformationTypeDef,
    QueryRuntimeStatisticsRowsTypeDef,
    QueryRuntimeStatisticsTimelineTypeDef,
    QueryStagePlanNodeTypeDef,
    QueryStageTypeDef,
    ResultReuseByAgeConfigurationTypeDef,
    StopCalculationExecutionRequestRequestTypeDef,
    StopQueryExecutionInputRequestTypeDef,
    TerminateSessionRequestRequestTypeDef,
    UntagResourceInputRequestTypeDef,
    UpdateDataCatalogInputRequestTypeDef,
    UpdateNamedQueryInputRequestTypeDef,
    UpdateNotebookInputRequestTypeDef,
    UpdateNotebookMetadataInputRequestTypeDef,
    UpdatePreparedStatementInputRequestTypeDef,
    QueryExecutionStatusTypeDef,
    CreateNamedQueryOutputTypeDef,
    CreateNotebookOutputTypeDef,
    CreatePresignedNotebookUrlResponseTypeDef,
    GetCalculationExecutionCodeResponseTypeDef,
    GetNamedQueryOutputTypeDef,
    ImportNotebookOutputTypeDef,
    ListApplicationDPUSizesOutputTypeDef,
    ListNamedQueriesOutputTypeDef,
    ListQueryExecutionsOutputTypeDef,
    StartCalculationExecutionResponseTypeDef,
    StartQueryExecutionOutputTypeDef,
    StartSessionResponseTypeDef,
    StopCalculationExecutionResponseTypeDef,
    TerminateSessionResponseTypeDef,
    BatchGetNamedQueryOutputTypeDef,
    GetPreparedStatementOutputTypeDef,
    BatchGetPreparedStatementOutputTypeDef,
    StartCalculationExecutionRequestRequestTypeDef,
    CalculationSummaryTypeDef,
    GetCalculationExecutionResponseTypeDef,
    GetCalculationExecutionStatusResponseTypeDef,
    ResultSetMetadataTypeDef,
    TableMetadataTypeDef,
    CreateDataCatalogInputRequestTypeDef,
    ListTagsForResourceOutputTypeDef,
    TagResourceInputRequestTypeDef,
    ListDataCatalogsOutputTypeDef,
    GetDataCatalogOutputTypeDef,
    GetDatabaseOutputTypeDef,
    ListDatabasesOutputTypeDef,
    RowTypeDef,
    ResultConfigurationTypeDef,
    ResultConfigurationUpdatesTypeDef,
    SessionConfigurationTypeDef,
    StartSessionRequestRequestTypeDef,
    ListEngineVersionsOutputTypeDef,
    WorkGroupSummaryTypeDef,
    ListExecutorsResponseTypeDef,
    ExportNotebookOutputTypeDef,
    GetNotebookMetadataOutputTypeDef,
    ListNotebookMetadataOutputTypeDef,
    ListNotebookMetadataInputRequestTypeDef,
    GetQueryResultsInputGetQueryResultsPaginateTypeDef,
    ListDataCatalogsInputListDataCatalogsPaginateTypeDef,
    ListDatabasesInputListDatabasesPaginateTypeDef,
    ListNamedQueriesInputListNamedQueriesPaginateTypeDef,
    ListQueryExecutionsInputListQueryExecutionsPaginateTypeDef,
    ListTableMetadataInputListTableMetadataPaginateTypeDef,
    ListTagsForResourceInputListTagsForResourcePaginateTypeDef,
    GetSessionStatusResponseTypeDef,
    SessionSummaryTypeDef,
    ListNotebookSessionsResponseTypeDef,
    ListPreparedStatementsOutputTypeDef,
    QueryExecutionStatisticsTypeDef,
    QueryRuntimeStatisticsTypeDef,
    ResultReuseConfigurationTypeDef,
    ListCalculationExecutionsResponseTypeDef,
    GetTableMetadataOutputTypeDef,
    ListTableMetadataOutputTypeDef,
    ResultSetTypeDef,
    WorkGroupConfigurationTypeDef,
    WorkGroupConfigurationUpdatesTypeDef,
    GetSessionResponseTypeDef,
    ListWorkGroupsOutputTypeDef,
    ListSessionsResponseTypeDef,
    GetQueryRuntimeStatisticsOutputTypeDef,
    QueryExecutionTypeDef,
    StartQueryExecutionInputRequestTypeDef,
    GetQueryResultsOutputTypeDef,
    CreateWorkGroupInputRequestTypeDef,
    WorkGroupTypeDef,
    UpdateWorkGroupInputRequestTypeDef,
    BatchGetQueryExecutionOutputTypeDef,
    GetQueryExecutionOutputTypeDef,
    GetWorkGroupOutputTypeDef,
)


def get_structure() -> AclConfigurationTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-athena` version is the same as related `aiobotocore` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_athena/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
